package com.taobao.txc.dubbo;

import com.taobao.txc.common.TxcContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.jdbc.core.JdbcTemplate;

import java.util.Random;

public class StockServiceImpl implements StockService {

    private static JdbcTemplate jdbcTemplate = null;

    public int updateStock(OrderDO orderDO) {
        String xid = TxcContext.getCurrentXid();
        System.out.println("updateStock is called in " + xid);
        int ret = jdbcTemplate.update("update stock set amount = amount - ? where product_id = ?",
                new Object[]{orderDO.getNumber(), orderDO.getProductId()});
        System.out.println("updateStock success.");
        return ret;
    }
    //获取总库存
    public Integer getSum() {
        System.out.println("getSum is called.");
        Integer sum = jdbcTemplate.queryForObject("select IF(ISNULL(SUM(amount)), 0, SUM(amount)) from stock", Integer.class);
        System.out.println("sum:" + sum);
        return sum;
    }

    public static void main(String []args) throws Exception{
        ClassPathXmlApplicationContext context = new ClassPathXmlApplicationContext(new String[]{"dubbo-stock-service.xml"});
        jdbcTemplate = (JdbcTemplate)context.getBean("jdbcTemplate");
        jdbcTemplate.update("truncate stock ");
        jdbcTemplate.update("insert into stock values(?, ?, ?)", new Object[]{1, new Random().nextInt(100), 100000});
        System.out.println("StockServie is running.");
        System.in.read();
    }
}
