package com.taobao.txc.springboot;


import com.taobao.txc.client.aop.annotation.TxcTransaction;
import com.taobao.txc.common.TxcContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Repository;

@Repository
public class AccDAO {
    @Autowired
    @Qualifier("primaryJdbcTemplate")
    private JdbcTemplate jdbcTemplate1;

    @Autowired
    @Qualifier("secondaryJdbcTemplate")
    private JdbcTemplate jdbcTemplate2;
    public void reset( int  money) {
        int id = 1;
        jdbcTemplate2.execute("truncate account_information");
        jdbcTemplate1.execute("truncate account_information");
        jdbcTemplate1.update("insert into account_information(id,money) values(?,?)", id,money);
        jdbcTemplate2.update("insert into account_information(id,money) values(1,0)");

    }
    @TxcTransaction
    public void transferAccount(int money) throws RuntimeException {
        String xid = TxcContext.getCurrentXid();
        System.out.println("add  money to db2  "+money);
        jdbcTemplate2.update("update account_information set money = money + ?",money);
        int acc_money = getMoney1().intValue();
        System.out.println("acc_money:"+acc_money+"    money:"+money);
        if(money > acc_money)
        {
            throw new RuntimeException("The account balance is not enough");
        }
        jdbcTemplate1.update("update account_information set money = money - ?",money);
        System.out.println("sub  money from db1  "+money);
    }



    public Integer getMoney1()
    {
        return  jdbcTemplate1.queryForObject("select money from account_information",Integer.class);
    }
    public Integer getMoney2()
    {
        return  jdbcTemplate2.queryForObject("select money from account_information",Integer.class);
    }




}
